;-----------------------------------------------------------------------------;
; READ D64 - D64 EXTRACTOR
; This utility extracts files from .d64 file (floppy disk image)
; onto hard disk drive. It works with IDE64 controller only.
;
; Copyright 1998-2001 Tomas Pribyl  (dundera@volny.cz)
;-----------------------------------------------------------------------------;

                   .include "kernal.asm"

buffer_lo = $fc
buffer_hi = $fd


quarter_buf = $1000


;version 1.0 - O.K.

;version 1.1 - Nov 03 1998 19:34:37 
;removed bug - now it works from all devices
;added       - skip all deleted files, include protected 


;version 1.2 - Apr 18 1999 12:04:52 
;rewritten for IDE64 plugin manager but unfinished


;version 1.3 - Nov 26 2001 15:47:00
;removed bug - wrong filename for writting

;version 1.4 -Dec 13 2001 19:41:51
;WORKING - separate directory for faster access



;Const
Source      = 1
Destination = 2

                   *= $0801
                   
                   .byte $26,$08,$0a,0
                   .byte $9e,"2128:"
                   .byte $8f," D64 TO IDE HDD EXTRACTOR"
                   
                   .byte $00,$41,$08,$14,0,$8f
                   .byte " > BY T.PRIBYL 2001 <",0
                   .byte 0,0,0,0,0



                   *= $0850
                   
                   lda #14
                   jsr chrout          ;lowercase
                   lda #$08
                   jsr chrout          ;disable SHIFT/CBM
                   
                   lda #$00
                   sta $9d             ;messages turn off
                   
                   lda #<d64name
                   ldy #>d64name
                   jsr $ab1e           ;print utility name
                   
                   ldy #$00
GetArc             jsr ChrIn
                   sta archivname,y
                   cmp #$0d
                   beq arcnameok
                   iny
                   cpy #$10            ;max.filename length
                   bne getarc


ArcNameOk          sty ArcLen          ;store archive filename lenght

                   jsr MakeTmpParts    ;creates 4 data parts and directory part

                   jsr Print_Dir       ;reads and prints dir

                   lda #$00            ;searching in dir starts on first entry
                   sta entry
                   
                   lda #18             ;first DIR sector for searching
                   sta last_dir_trk
                   lda #1
                   sta last_dir_sect

                   lda #<input
                   ldy #>input
                   jsr $ab1e           ;print "input pattern"
                   
                   lda #$00
                   sta $99             ;keyboard input


                   ldy #$00
GetName            jsr ChrIn
                   sta ExtractName,y   ;filename for extracting
                   cmp #$0d
                   beq end_name
                   iny
                   cpy #$10            ;max.filename length
                   bne GetName
                   
end_name           sty ExNamelenth     ;store extract filenamelength

                   
Extract_Next       jsr Search_Name     ;looking for file in directory
                   bcs end_extract     ;nothing found, end of extracting
                   
                   jsr Extract_File    ;file found, extract it
                   jmp extract_next    ;repeat for all files



;------------------------------------------------------
; EXTRACTING FINISHED

end_extract        lda #Source
                   jsr Close
                   lda #Destination
                   jsr Close
                   jsr ClAll
                   
                   jsr RemoveTmpParts  ;delete temporary files

                   lda #<end_txt       ;end of extracting
                   ldy #>end_txt
                   jmp $ab1e           ;END OF PROGRAM









;-------------------------------------------------------
; EXTRACT FILE FROM D64
; Input: X-sector beginning
;        Y-track beginning
;
; Ouptut : file on actual disk
;
;-------------------------------------------------------                   
Extract_file       tya
                   pha
                   txa
                   pha                 ;store first sector pointer

                   lda #$03
                   sta $9a             ;set screen as output device

                   ldy #$00
print_sign         lda extr_txt,y      ;print EXTRACTING
                   beq cont
                   jsr ChrOut
                   iny
                   jmp print_sign


cont               ldy #$00
tiskfile           lda ($bb),y
                   cmp #"/"
                   beq slash
                   cmp #"*"
                   bne notslash
slash              lda #"-"
                   sta ($bb),y
notslash           jsr ChrOut
                   iny
                   cpy $b7
                   bne tiskfile
                   
                   ldy $b7             ;add to filename ,x,W
                   lda #","
                   sta ($bb),y
                   iny
                   lda atribut
                   sta ($bb),y
                   iny
                   lda #","
                   sta ($bb),y
                   iny
                   lda #"W"
                   sta ($bb),y
                   iny
                   sty $b7
                   
                   inc $d3             ;move cursor
                   
                   
                   lda #Destination
                   ldx $ba
                   ldy #1              ;open for writting
                   jsr SetLfs
                   
                   jsr Open
                   
                   pla                 ;restore first sector pointer
                   tax
                   pla
                   tay

;-----------------------------------------------------                   
cont_extract       jsr Read_Sector     ;read desired sector

                   ldx #Destination
                   jsr ChkOut          ;set output to destination file
                   
                   lda #$36
                   sta $01             ;enable RAM
                   
                   ldy #$00
                   lda (buffer_lo),y
                   cmp #$00
                   beq lastsector
                   
;----------------------------------  store data
; store whole sector
                   ldy #$00
                   lda (buffer_lo),y
                   pha                 ;store next track
                   iny
                   lda (buffer_lo),y
                   pha                 ;store next sector
                   
                   clc
                   lda buffer_lo
                   adc #$02
                   sta buffer_lo       ;move pointer to first data byte in sector
                   
                   lda #buffer_lo
                   ldx #254            ;sector without first word (track,sect)
                   ldy #0
                   jsr HddWrite
                   
                   pla
                   tax                 ;restore next sector
                   pla
                   tay                 ;restore next track
                   jmp cont_extract    ;proceed next data


;---------------------------------------------------                   
; store rest of last sector
lastsector         ldy #$01
                   lda (buffer_lo),y
                   sta lenth_block
                   inc lenth_block     ;calculate offset of last byte
                   iny

store_last         lda (buffer_lo),y
                   jsr ChrOut
                   iny
                   cpy lenth_block
                   bne store_last
                   
                   ldy $d3
                   lda #122            ;put proceed char on screen
                   sta ($d1),y
                   
                   lda #Destination
                   jsr Close           ;close destination file
                   
                   lda #$37
                   sta $01             ;enable ROM
                   rts







;-----------------------------------------------------------------------------                   
;
; PRINTS DIR ON SCREEN

                   
Print_dir          lda #$0d
                   jsr ChrOut          ;next line
                   
                   ldx #1              ;sector (begining of directory)
                   ldy #18             ;track
                   
next_dir_sect      jsr read_sector     ;reads 1. sector of directory

                   ldy #$00
                   lda (buffer_lo),y
                   sta next_trk        ;store number of next TRACK
                   iny
                   lda (buffer_lo),y
                   sta next_sect       ;store number of next SECTOR
                   
                   lda #$00
                   sta Entry           ;initialize entry in DIR to first
                   
print_entry        lda entry
                   asl
                   asl
                   asl
                   asl
                   asl
                   sta buffer_lo       ;calculate offset in actual sector
                   
                   ldy #$02
                   lda (buffer_lo),y   ;00-file deleted, next entry
                   beq next_entry
                   
                   and #$0f
                   tay
                   
                   lda Type,y          ;type of file/dir
                   jsr ChrOut          ;put it on the screen
                   
                   lda #$20            ;wordpadding
                   jsr ChrOut
                   jsr ChrOut
                   

                   ldy #$05
printname          lda (buffer_lo),y   ;read filename from dir entry
                   bne PrintDirName
                   rts
                   
PrintDirName       jsr ChrOut
                   iny
                   cpy #$15            ;max.end of filename
                   bne printname
                   
                   lda #$20
                   jsr ChrOut          ;wordpadding
                   
                   ldy #$1e            ;blocks LOW
                   lda (buffer_lo),y
                   tax
                   iny
                   lda (buffer_lo),y   ;blocks HIGH
                   jsr $bdcd           ;print BLOCKS
                   
                   lda #$0d
                   jsr ChrOut          ;next line

;-------------------------------------------------------                   
next_entry         inc entry           ;next entry in dir
                   lda entry
                   cmp #$08
                   bne print_entry
                   
                   ldy next_trk        ;all entry in actual sector finished
                   cpy #$00
                   bne ContNextDirSect ;test if it's last sector of dir
                   rts

ContNextDirSect    ldx next_sect      
                   jmp next_dir_sect   ;no, continue (read next sector)






;------------------------------------------------------------------------------
;
; Looks for filename in directory and returns beginning of file
;
; Input: filename, filenamelength
; Output: track and sector of beginning file
;         if file was found then CY=0 otherwise CY=1
;------------------------------------------------------------------------------
Search_Name        lda #$36            ;RAM enable
                   sta $01
                   
                   ldx last_dir_sect
                   ldy last_dir_trk

next_dir_sect1     jsr Read_Sector     ;reads last readed dir sector

                   ldy #$00
                   lda (buffer_lo),y
                   sta next_trk        ;store next dir track
                   iny
                   lda (buffer_lo),y
                   sta next_sect       ;store next dir sector
                   
new_entry          lda entry
                   asl
                   asl
                   asl
                   asl
                   asl
                   sta buffer_lo

                   ldy #$02
                   lda (buffer_lo),y
                   and #%00111111      ;ignore VISIBLE & PROTECT bit
                   cmp #$00
                   beq next_search     ;DEL file skip too
                   
                   tay
                   lda Type,y
                   sta Atribut         ;store char of file attribut
                    
                   ldy #$05            ;beginning of filename in dir entry
                   ldx #$00            ;beginning of desired filename
compare_name       lda ExtractName,x
                   cmp #$2a            ;"*"
                   beq name_ok
                   cmp (buffer_lo),y
                   bne next_search     ;Different filename
                   iny
                   inx
                   cpx exnamelenth
                   bne compare_name 
                   
                   
name_ok            ldx #$00
                   ldy #$05
movename           lda (buffer_lo),y
                   cmp #$a0
                   beq endname
                   sta destname,x
                   iny
                   inx
                   cpx #$10            ;max.filenamelength
                   bne movename
                   
endname            txa                 ;filenamelength
                   ldx #<destname
                   ldy #>destname
                   jsr SetNam          ;set original name for extracting
                   
                   inc entry           ;set next entry for searching
                   
                   lda entry           ;if entry is in new sector...
                   cmp #$08
                   bne SectNotPassed

                   lda #$00            ;...then initialize new entry...
                   sta entry
                   lda next_sect       ;...and set next dir track & sector
                   sta last_dir_sect   ;as last dir sector
                   lda next_trk
                   sta last_dir_trk
                   jmp GetFileVector   ;get pointer of first file sector
                   
                   
SectNotPassed      lda sector          ;store actual sector for next searching
                   sta last_dir_sect
                   lda track           ;store actual track for next searching
                   sta last_dir_trk

GetFileVector      ldy #$03            ;first TRACK of file
                   lda (buffer_lo),y
                   pha
                   iny                 ;first SECTOR of file
                   lda (buffer_lo),y
                   tax                 ;start sector of file
                   pla
                   tay                 ;start track of file
                   
                   lda #$37
                   sta $01             ;enable ROM
                   clc                 ;file was found OK.
                   rts
                   

;----------------------------------------------------------------------------
; Different filename
                   
next_search        inc entry           ;proceed next entry
                   lda entry
                   cmp #$08            ;last entry in this sector?
                   beq old             ;yes
                   jmp new_entry
                   
old                ldy next_trk        ;test if this directory sector is last
                   cpy #$00
                   beq end_of_dir1     ;yes, end of extracting
                   
                   ldx next_sect
                   lda #$00
                   sta entry           ;no, set to begining of next track
                   jmp next_dir_sect1
                   
end_of_dir1        lda #$37
                   sta $01             ;enable ROM
                   sec                 ;file not found, end of extracting
                   rts






;------------------------------------------------------------------------------
; rutine READ SECTOR
; Input: X sektor
;        Y track
;
; Output: BUFFER_LO/HI pointer to sector in RAM


read_sector        stx sector
                   sty track
                   
                   dey
                   tya                 ;track 1 is first
                   asl                 ;*2
                   tay
                   
                   lda tracks_start,y
                   sta block_lo
                   lda tracks_start+1,y
                   sta block_hi        ;store linear sector number of previos tracks
                   
                   clc                 ;and adds number of sectors in this track
                   lda sector
                   adc block_lo
                   sta block_lo
                   bcc not_cnt
                   inc block_hi        ;block_lo/hi is linear sector number
                   
not_cnt            ldy #$00
                   
Divide             sec
                   lda block_lo
                   sbc #$ab            ;divide linear sector number by number
                   tax                 ;of sectors oncetime stored in RAM
                   lda block_hi
                   sbc #$00
                   bcc EndDivide
                   
                   sta block_hi
                   stx block_lo
                   iny
                   jmp Divide          ;continue dividing

                   
EndDivide          sty quarter         ;number of quarter in which is actual sector located

                   lda block_lo        ;actual quarter is in RAM from $1000
                   clc                 ;therefore i must add $1000 to block_hi/lo
                   adc #>quarter_buf   ;
                   sta block_lo        ;
                   
Read               lda quarter
                   cmp act_quarter     ;test if required part is in RAM
                   beq quarter_ready   ;part is already in RAM
                   

;---------------------------------  required data part isn't in RAM, load it...                   
                   clc                   
                   adc #"0"
                   sta TempFileName+10 ;convert to ASCII

                   ldx #<TempFileName+2 ;temporary filename
                   ldy #>TempFileName+2
                   lda #D64Name-TempFileName+2
                   jsr SetNam
                   
                   lda #Source
                   ldx $ba
                   ldy #0
                   jsr SetLfs

                   jsr Open            ;open actual part
                   bcs error
                   
                   lda quarter
                   sta act_quarter     ;store number of acutal part
                   
                   ldx #Source
                   jsr ChkIn
                   
                   lda #<quarter_buf   ;beginning of databuffer
                   sta $fa
                   lda #>quarter_buf
                   sta $fb
                   
                   ldx #$00
                   ldy #$ab            ;read 171 sectors into buffer
                   lda #$fa
                   jsr hddread
                   bcs error

;--------------------------------- required data part is in RAM
quarter_ready      lda #Source
                   jsr Close
                   
                   lda block_lo        ;ukazatel na sektor v pameti
                   sta buffer_hi
                   lda #$00
                   sta buffer_lo
                   rts
                   

;----------------------------------------------------------------------------
error              lda #$37
                   sta $01             ;enable ROM
                   lda #Source
                   jsr close
                   jsr clall
                   lda #<err_txt
                   ldy #>err_txt
                   jmp $ab1e








;----------------------------------------------------------------------------
;
;      Opens source D64 file and makes 4 parts with 171 sectors
;      It will rewrite TMP file if exists!
;

MakeTmpParts       lda #<CreateTxt
                   ldy #>CreateTxt
                   jsr $ab1e

                   lda #$36
                   sta $01             ;enable whole RAM
                   
                   lda #00             
                   sta Act_Quarter     ;initialize number of parts
                   
                   ldx #<ArchivName    ;D64 filename
                   ldy #>ArchivName
                   lda ArcLen          ;D64 filenamelength
                   jsr SetNam
                   
                   lda #Source
                   ldx $ba
                   ldy #0
                   jsr SetLfs
                   
                   jsr Open
                   bcs Error
                   
CreateNextPart     ldx #Source
                   jsr ChkIn
                   
                   lda #<quarter_buf   ;beginning of databuffer
                   sta $fa
                   lda #>quarter_buf
                   sta $fb
                   
                   ldx #$00
                   ldy #$ab            ;read 171 sectors into buffer
                   lda #$fa            ;beginning - low byte pointer
                   jsr HddRead
                   bcs Error
                   
                   txa
                   pha
                   tya
                   pha                 ;store readed block length

                   lda Act_Quarter     ;part number
                   clc
                   adc #"0"
                   sta TempFileName+10 ;convert it to ASCII

                   ldx #<TempFileName  ;temporary filename
                   ldy #>TempFileName
                   lda #D64Name-TempFileName ; temporary filenamelength
                   jsr SetNam
                   
                   lda #Destination    ;destination file
                   ldx $ba
                   ldy #1              ;secondary address=write
                   jsr SetLfs                           
                   
                   jsr Open            ;create new part
                   bcs error
                   
                   ldx #Destination
                   jsr ChkOut          ;set output to opened file
                   
                   pla
                   tay
                   pla
                   tax                 ;restore block length
                   
                   lda #$fa
                   jsr HddWrite        ;write buffer to opened file
                   bcc WrittenOk
                   jmp Error
                   
WrittenOk          lda #Destination
                   jsr Close
                   
                   inc Act_Quarter     ;next part
                   lda Act_Quarter 
                   cmp #$04            ;last part created?
                   bne CreateNextPart
                   
                   lda #Source
                   jsr Close
                   jsr ClAll
                   
                   lda #$37            ;enable ROM
                   sta $01
                   lda #<OkTxt
                   ldy #>OkTxt
                   jsr $ab1e
                   rts
                   


;----------------------------------------------------------------------------
RemoveTmpParts     lda #<DeleteTxt
                   ldy #>DeleteTxt
                   jsr $ab1e           ;"Deleting temporary files..."

                   lda #$00
                   sta Act_Quarter     ;initialize part to be removed
                   
                   lda #"S"
                   sta TempFilename    ;put scratch char into filename
                   
RemoveNextTmpPart  lda Act_Quarter     ;part number
                   clc
                   adc #"0"
                   sta TempFileName+10 ;convert it to ASCII

                   ldx #<TempFileName  ;temporary filename
                   ldy #>TempFileName
                   lda #D64Name-TempFileName ; temporary filenamelength
                   jsr SetNam
                   
                   lda #Destination    ;destination file
                   ldx $ba
                   ldy #15              ;secondary address=command
                   jsr SetLfs                           
                   
                   jsr Open            ;delete TMP file
                   
                   lda #Destination
                   jsr Close           ;close deleted file
                   
                   inc Act_Quarter
                   lda Act_Quarter
                   cmp #$04
                   bne RemoveNextTmpPart
                   
                   lda #<OkTxt
                   ldy #>OkTxt
                   jsr $ab1e           ;"OK."
                   rts

                   

;----------------------------------------
;Internal variables

next_trk           .byte 0 
next_sect          .byte 0   ;next sector pointer


sector             .byte 0   ;desired sector pointer
track              .byte 0
entry              .byte 0   ;actual entry in sector

block_lo           .byte 0   
block_hi           .byte 0   ;linear sector number

quarter            .byte 0   ;desired data part
act_quarter        .byte 0   ;actual data part in memory

exnamelenth        .byte 0   ;filenamelength of extracted file

last_dir_sect      .byte 0   ;last sector of directory (continue searching there)
last_dir_trk       .byte 0   ;last track of directory

lenth_block        .byte 0   ;delka posledniho sektoru

arclen             .byte 0   ;archieve filenamelength

atribut            .byte 0   ;file attribut
;---------------------------------------

type               .text "DSPUR"                ;attributes

archivname         .text "0123456789ABCDEF"     ;D64 filename

extractname        .text "0123456789ABCDEF"     ;extract filename

destname           .text "0123456789ABCDEF,p,r" ;extracted filename

TempFilename       .text "@:!D64TEMP0"          ;temporary filename


d64name            .text $93,"d64-ide EXTRACTOR v1.4 BY t.pRIBYL 2001",$0d
                   .text $0d,"iNPUT d64 NAME: ",0

input              .text $0d,"INPUT PATTERN: ",0

extr_txt           .text $0d,"EXTRACTING: ",0

end_txt            .text $0d,$0d,"END OF EXTRACTING...",$0d,0

err_txt            .text $0d,"disk error!!!",0

CreateTxt          .text $0d,"cREATING TEMPORARY FILES... ",0
DeleteTxt          .text $0d,$0d,"dELETING TEMPORARY FILES... ",0
OkTxt              .text "OK.",0





;----------------------------------------------------------------------
; in RAM can be only 171 blocks 

                                 ;how many sectors are on tracks
tracks_start       .byte 0,0     ;track 1       21 sectors per track
                   .byte 21,0    ;track 2
                   .byte 42,0    ;track 3
                   .byte 63,0    ;track 4
                   .byte 84,0    ;track 5
                   .byte 105,0   ;track 6
                   .byte 126,0   ;track 7
                   .byte 147,0   ;track 8
                   .byte 168,0   ;track 9
                   .byte 189,0   ;track 10
                   .byte 210,0   ;track 11
                   .byte 231,0   ;track 12
                   .byte 252,0   ;track 13                      
                   .byte 17,1    ;track 14    273. blok
                   .byte 38,1    ;track 15
                   .byte 59,1    ;track 16
                   .byte 80,1    ;track 17
                   .byte 101,1   ;track 18     19 sectors per track
                   .byte 120,1   ;track 19
                   .byte 139,1   ;track 20
                   .byte 158,1   ;track 21
                   .byte 177,1   ;track 22
                   .byte 196,1   ;track 23
                   .byte 215,1   ;track 24
                   .byte 234,1   ;track 25     18 sectors per track
                   .byte 252,1   ;track 26    2.part
                  
                   .byte 14,2    ;track 27
                   .byte 32,2    ;track 28
                   .byte 50,2    ;track 29
                   .byte 68,2    ;track 30                      (580)
                  
                   .byte 86,2    ;track 31     17 sectors per track
                   .byte 103,2   ;track 32
                   .byte 120,2   ;track 33
                   .byte 137,2   ;track 34
                   .byte 154,2   ;track 35    ;                 (666.sektor)
                  